<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponse"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponseCode"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceRequest"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNetworkException"%>
<%@ page import="com.invoqsystems.apex.web.exceptions.AlarmPointTimeOutException"%>
<%@ page import="com.alarmpoint.servicemanager.cm.*"%>

<%@ include file="includes/mobilegatewaysession.jsp"%>
<%

//Update the change with all the changes
ServiceManagerChange change = (ServiceManagerChange)session.getAttribute("change");
if(change != null){
  for(String key: change.getOriginalMap().keySet()){
    if(request.getParameterValues(key) != null && request.getParameterValues(key).length == 2)
      change.addUpdate(key, "true");
    else if(request.getParameter(key) != null)
      change.addUpdate(key, (String)request.getParameter(key));
    else if(request.getParameter(key+"-DATE") != null)
      change.addUpdate(key, XMLDateParser.getXMLDate((String)request.getParameter(key+"-DATE")));
  }
}

String action = request.getParameter("action");
if("create".equalsIgnoreCase(action))
//We are trying to create a new change
{
  ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
  ExternalServiceResponse resps;
  esr.setAction("createChange");
  esr.addToken("change", change);
  %>
  <%@ include file="includes/sendRequest.jsp"%>
  <%
  String changeID = null;
  String status = null;
  if(resps.getResponse() == null)
  {
    status = "failed to create change";
  }
  else if(resps.getResponse() instanceof String)
  {
    status = (String)resps.getResponse();
  }
  else if(resps.getResponse() != null)
  {
    String[] rtn = (String[])resps.getResponse();
    changeID = rtn[0];
    status = rtn[1];
  }

  if(status != null)
  {
    status = "?errorMessage="+status;
    %>
    <jsp:forward page="<%=response.encodeURL("createChange.jsp"+status)%>"/>
    <%
  }
  else
  {
    status = "&message=Success";
    %>
    <jsp:forward page="<%=response.encodeURL("loadChange.jsp?ChangeID="+changeID+status)%>"/>
    <%
  }
}

else if ( "Add Activity".equalsIgnoreCase( action ) )
{
  ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
  ExternalServiceResponse resps;
  ServiceManagerChange updatedChange = (ServiceManagerChange)session.getAttribute("change");
  String changeID = updatedChange.getTextValue("header,ChangeID");
  esr.setAction("addActivity");
  esr.addToken("changeID", changeID);
  esr.addToken("activityText", (String)request.getParameter("ActivityText"));
  %>
  <%@ include file="includes/sendRequest.jsp"%>
  <%

  String exception = (String)resps.getResponse();
  String status;
  if ( exception != null && exception.length() > 0 )
  {
      status = "?errorMessage="+exception;
      %>
      <jsp:forward page="<%=response.encodeURL("updateChange.jsp"+status)%>"/>
      <%
  }
  else
  {
    status = "&message=Activity Added";
    %>
    <jsp:forward page="<%=response.encodeURL("updateChange.jsp?tab=Activities&ChangeID="+changeID+status)%>"/>
    <%
  }
}
else if ("Approve".equalsIgnoreCase(action) || "Deny".equalsIgnoreCase(action))
{
    ServiceManagerChange updatedChange = (ServiceManagerChange)session.getAttribute("change");
    String changeID = updatedChange.getTextValue("header,ChangeID");
    String messagePrefix = "Approve".equalsIgnoreCase(action) ? "Approved: " : "Denied: ";
    String updateType = "Approve".equalsIgnoreCase(action) ? "approval." : "denial.";
    if (request.getParameter("ActivityText") == null)
    {
      %>
      <jsp:forward page="<%=response.encodeURL("updateChange.jsp?tab=add_activity&approvedeny=" + action + "&ChangeID=" + changeID + "&message=Please enter a reason for the " + updateType)%>"/>
      <%
    }
    else
    {
        ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
        ExternalServiceResponse resps;
        esr.setAction("approveDenyChange");
        esr.addToken("operation", action);
        esr.addToken("changeID", changeID);
        esr.addToken("message", messagePrefix + (String)request.getParameter("ActivityText"));
        %>
        <%@ include file="includes/sendRequest.jsp"%>
        <%

        String status = "&message=";
        
        if (resps.getResponse() instanceof List)
        {
	        List<String> messages = (List<String>)resps.getResponse();
	        for (String message : messages)
	        {
	            status += "<p>" + message + "</p>";
	        }
	    }
        else if (resps.getResponse() instanceof String)
        {
            status = "&errorMessage=" + (String)resps.getResponse();
        }
        %>
        <jsp:forward page="<%=response.encodeURL("updateChange.jsp?tab=Activities&ChangeID="+changeID+status)%>"/>
        <%
    }
}
else if("update".equalsIgnoreCase(action))
//We are trying to save the updated change
{
  //Add processing for required fields
  //If we close a ticket we need FixType CloseCode and Resolution
  if("Closed".equals(change.getTextValue("IMTicketStatus"))){
    String reqMessage = "";
    if("".equals(change.getTextValue("ResolutionFixType")) || change.getTextValue("ResolutionFixType") == null){
      reqMessage += " Res Type";
    }
    if("".equals(change.getTextValue("ClosureCode")) || change.getTextValue("ClosureCode") == null){
      if(!"".equals(reqMessage))
        reqMessage += ",";
      reqMessage += " Res Code";
    }
    if("[]".equals(change.getTextValue("Resolution")) || change.getTextValue("Resolution") == null){
      if(!"".equals(reqMessage))
        reqMessage += ",";
      reqMessage += " Res";
    }
    if(!"".equals(reqMessage)){
      reqMessage = "The following fields are required to close a ticket:" + reqMessage;
      %>
      <jsp:forward page="<%=response.encodeURL("updateChange.jsp?tab=add_resolution&errorMessage="+reqMessage)%>"/>
      <%
    }
  }
  %>
  <jsp:forward page="<%=response.encodeURL("diffChange.jsp")%>"/>
  <%
}
else if("go".equalsIgnoreCase(action))
//We are trying to navigate to another page
{
%>
  <jsp:forward page="<%=response.encodeURL(request.getParameter("menuURL"))%>"/>
<%
}
else
{
  Enumeration<String> parameterNames = request.getParameterNames();
  while(parameterNames.hasMoreElements())
  {
    String field = parameterNames.nextElement();
    String key = field.replaceFirst(".*-", "");
    String pageURL = request.getParameter("pageURL");
    String tab = request.getParameter("tab");

    if(field.startsWith("searchOperator"))
    {
      String searchString = "";
      if("AssigneeName".equalsIgnoreCase(key))
      {
        searchString = "&searchField=assignment.groups";
        searchString += "&searchOperator=EQUALS";
        searchString += "&searchValue="+change.getTextValue("PrimaryAssignmentGroup");
      }
      String searchUrl = "searchOperators.jsp?url="+pageURL+"&tab="+tab+"&field="+key+searchString;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
    else if(field.startsWith("searchAssignments"))
    {
      String searchUrl = "searchAssignments.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
    else if(field.startsWith("searchContacts"))
    {
      String searchUrl = "searchContacts.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
    else if(field.startsWith("searchCategory"))
    {
      String searchUrl = "searchCategory.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
    else if(field.startsWith("searchSubcategory"))
    {
      String searchString = "";
      if("Subcategory".equalsIgnoreCase(key))
      {
        searchString = "&searchField=category";
        searchString += "&searchOperator=EQUALS";
        searchString += "&searchValue="+change.getTextValue("Category");
      }
      String searchUrl = "searchSubcategory.jsp?url="+pageURL+"&tab="+tab+"&field="+key+searchString;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
    else if(field.startsWith("searchProductType"))
    {
      String searchString = "";
      if("ProductType".equalsIgnoreCase(key))
      {
        searchString = "&searchField=subcategory";
        searchString += "&searchOperator=EQUALS";
        searchString += "&searchValue="+change.getTextValue("Subcategory");
      }
      String searchUrl = "searchProductType.jsp?url="+pageURL+"&tab="+tab+"&field="+key+searchString;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
    else if(field.startsWith("searchProblemType"))
    {
      String searchString = "";
      if("ProblemType".equalsIgnoreCase(key))
      {
        searchString = "&searchField=product.type";
        searchString += "&searchOperator=EQUALS";
        searchString += "&searchValue="+change.getTextValue("ProductType");
      }
      String searchUrl = "searchProblemType.jsp?url="+pageURL+"&tab="+tab+"&field="+key+searchString;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
    else if(field.startsWith("searchConfigItem"))
    {
      String searchUrl = "searchConfigItem.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
    else if(field.startsWith("searchType"))
    {
      String searchUrl = "searchType.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
    else if(field.startsWith("searchResolutionCode"))
    {
      String searchUrl = "searchResolutionCode.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
  }
}
%>
