<style type="text/css" media="all" title="xMatters mobile access">
  @import url("/mg/css/general.css");
  label.required {
    font-weight: bold;
    color: #990033;
  }
</style>
<%
  //ServiceManagerChange updatedChange = (ServiceManagerChange)session.getAttribute("change");
  String changeID = change.getTextValue("header,ChangeID");
  
  ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
  ExternalServiceResponse resps;
  esr.setAction("getChangeApprovalRecords");
  esr.addToken("changeID", changeID);
  esr.addToken("action", "RetrieveChangeApprovalListRequest");

  %>
  <%@ include file="sendRequest.jsp"%>
  <%
  List<ServiceManagerChange> changeApprovals = new ArrayList<ServiceManagerChange>();
  String message = "";
  if(resps.getResponse() instanceof String)
  {    
      message = "<div class=\"msg-error\">"+resps.getResponse()+"</div>";
  }
  else
  {
      changeApprovals = (List<ServiceManagerChange>)resps.getResponse();
  }

  if ( changeApprovals.size() > 0 )
  {
      // There should only be one instance as this query is based on the change number, so we will
      // snag the first element in the collection
      ServiceManagerChange approval = changeApprovals.get(0);

  %>
    <table class="no-border">
      <tr>
        <td style="vertical-align: middle;" class="align-right"><label>Approval Type:</label></td>
        <td><%=approval.getTextValue("ApprovalType") %></td>
      </tr>
      <tr>
        <td style="vertical-align: middle;" class="align-right"><label>Requested By:</label></td>
        <td><%=approval.getTextValue("RequestedBy") %></td>
      </tr>
      <tr>
        <td style="vertical-align: middle;" class="align-right"><label>Approval Status:</label></td>
        <td><%=approval.getTextValue("ApprovalStatus") %></td>
      </tr>
      <tr>
        <td style="vertical-align: middle;" class="align-right"><label>Current Sequence:</label></td>
        <td><%=approval.getTextValue("CurrentSequence") %></td>
      </tr>
    </table>

    <table class="no-border">
      <tr>
        <td style="vertical-align: middle;" class="align-left">&nbsp;</td>
      </tr>
      <tr>
        <td style="vertical-align: middle;" class="align-left"><label>Currently Pending Approvals</label></td>
      </tr>
    </table>
    
    <table>
       <tr><th>Grp/Oper</th></tr>
       <%
       if (approval.getListValue("PendingGroup") != null)
       {
		   for (String pendingGroup : approval.getListValue("PendingGroup"))
		   {
		   %>
		   <tr>
		     <td><%=pendingGroup%></td>
		   </tr>
		   <%
		   }
       }
       else
       {
         %>
         <tr>
           <td>&nbsp;</td>
         </tr>
         <%
       }
       %>
    </table>
    
    <table class="no-border">
      <tr>
        <td style="vertical-align: middle;" class="align-left">&nbsp;</td>
      </tr>
      <tr>
        <td style="vertical-align: middle;" class="align-left"><label>Future Approvals</label></td>
      </tr>
    </table>
    
    <table>
       <tr><th>Seq</th><th>Grp/Oper</th></tr>
    <%
    if (approval.getListValue("FutureGroup") != null)
    {
	    for (int i=0; i<approval.getListValue("FutureGroup").size(); i++)
	    {
	        String futureGroup = ((List<String>)approval.getListValue("FutureGroup")).get(i);
	        String futureSequence = ((List<String>)approval.getListValue("FutureSequence")).get(i);
	    %>
	    <tr>
	      <td><%=futureSequence%></td>
	      <td><%=futureGroup%></td>
	    </tr>
	    <%
	
	    }
    }
    else
    {
    %>
      <tr>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
      </tr>
    <%
    }
    %>
    </table>

    <table class="no-border">
      <tr>
        <td style="vertical-align: middle;" class="align-left">&nbsp;</td>
      </tr>
      <tr>
        <td style="vertical-align: middle;" class="align-left"><label>Completed Approval Actions</label></td>
      </tr>
    </table>
    
    <table>
       <tr><th>Grp/Oper</th><th>Date</th><th>Action</th></tr>
    <%
    
    if (approval.getListValue("ApprovedGroup") != null)
    {
	    for (int i=0; i<approval.getListValue("ApprovedGroup").size(); i++)
	    {
	        String approvedGroup = ((List<String>)approval.getListValue("ApprovedGroup")).get(i);
	        String approvedDate = ((List<String>)approval.getListValue("ApprovedDate")).get(i);
	        String approvedAction = ((List<String>)approval.getListValue("ApprovedAction")).get(i);
	    %>
	    <tr>
	      <td><%=approvedGroup%></td>
	      <td><%=approvedDate%></td>
	      <td><%=approvedAction%></td>
	    </tr>
	    <%
	
	    }
    }
    else
    {
    %>
      <tr>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
      </tr>
    <%
    }
    %>
    </table>

    <%
    // Display Approve/Deny options only if the logged in user is in the pending approval list (explicit user or member of group)
    String currentUser = (String)session.getAttribute("smUser");
    List<ServiceManagerChange> groups = (List<ServiceManagerChange>)session.getAttribute("smUserGroups");

    boolean canApproveDeny = false;
    
    // Iterate the list of pending groups...if the pending group matches the user or the approval group the user belongs to, exit the loop 
    if (approval.getListValue("PendingGroup") != null)
    {
	    for (String pendingGroup : approval.getListValue("PendingGroup"))
	    {
	       if (currentUser.equalsIgnoreCase(pendingGroup))
	       {
	           canApproveDeny = true;
	           break;
	       }
	               
	       // See if the user is in the approval group
	       for (ServiceManagerChange group : groups)
	       {
	           if (group.getTextValue("name").equalsIgnoreCase(pendingGroup))
	           {
	               canApproveDeny = true;
	               break;
	           }
	       }
	    }
    }

    if (canApproveDeny)
    {
    %>
      <p> 
        <input type="submit" name="action" value="Approve" />
        <input type="submit" name="action" value="Deny" />
      </p>
    <%           
    }

  }
  else
  {
      if ("".equals(message))
      {
        out.print( "<div class=\"msg-success\">No Approvals</div>" );
      }
      else
      {
        out.print(message);
      }
  }
%>