<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>

<%@ page import="java.util.*" %>
<%@ page import="java.sql.*" %>
<%@ page import="java.net.URLDecoder" %>

<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.*" %>
<%@ page import="org.apache.commons.lang.StringEscapeUtils" %>

<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.PredicateBean" %>
<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBean" %>
<%@ page import="com.invoqsystems.apex.web.cocoon.actions.WebUIUtility" %>

<%@ page import="com.alarmpoint.servicemanager.cm.ServiceManagerScriptObject" %>

<jsp:useBean id="subscriptionBean"
             class="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBeanImpl"
             scope="session" />

<jsp:useBean id="serviceManagerCmBean"
             class="com.alarmpoint.servicemanager.cm.ServiceManagerScriptObject"
             scope="page" />

<%@ include file="SMCMConfig.jsp" %>

<page>



<window-popup onload="updateCurrentSubcategoryNames();">

<%
    // =================================================================================================================
    // parse the categories and produce a Query string for the WS call
    // =================================================================================================================
    final String categoriesRaw = request.getParameter( CATEGORY_PREDICATE_NAME );
    if ( categoriesRaw == null )
    {
      throw new IllegalArgumentException( CATEGORY_PREDICATE_NAME + " must be pased into page" );
    }
    
    URLDecoder urlDecoder = new URLDecoder();    
    final String categories = urlDecoder.decode( categoriesRaw, "UTF-8" );

    String[] categoriesArray = categories.split( "," );
    String categoriesQuery = "(1=2)"; // should always be replaced
    String categoriesDisplay = "";
    boolean firstCategory = true;
    for( String category : categoriesArray )
    {
        if ( firstCategory )
        {
            categoriesQuery = "(";
        }
        else
        {
            categoriesDisplay += ", ";
            categoriesQuery += " or ";
        }
        firstCategory = false;
        categoriesDisplay += StringEscapeUtils.escapeHtml( category.trim() );
        categoriesQuery += String.format( "category = \"%s\"", category.trim() );
    }
    categoriesDisplay += ".";
    categoriesQuery += ") ";


    // =================================================================================================================
    // build subcategory filter to handle post from this page and determine if post back operation
    // =================================================================================================================
    String filterValueRaw =  request.getParameter("FilterValue");
    String filterValue = filterValueRaw != null ? urlDecoder.decode( filterValueRaw, "UTF-8" ) : null;

    String[] itemsAllRaw = request.getParameterValues("items");
    String[] items = null;
    if( itemsAllRaw != null )
    {
        items = new String[itemsAllRaw.length];
        for ( int ii = 0; ii < itemsAllRaw.length; ii++ )
        {
            items[ii] = urlDecoder.decode( itemsAllRaw[ii], "UTF-8" );
        }
    }

    String webServiceFilterValue = filterValue; 
    String filterOperator = request.getParameter("FilterOperator");
    final boolean processingPostBack = ( filterOperator != null );
    String webServiceQueryOp = "=";  // MATCHES
    if( filterValue != null )
    {

        if( filterOperator.equals( "STARTS_WITH" ) )
        {
            webServiceQueryOp = "like";
            webServiceFilterValue = webServiceFilterValue + "*";
        }
        else if( filterOperator.equals( "ENDS_WITH" ) )
        {
            webServiceQueryOp = "like";
            webServiceFilterValue = "*" + webServiceFilterValue;
        }
        else if( filterOperator.equals( "CONTAINS" ) )
        {
            webServiceQueryOp = "like";
            webServiceFilterValue = "*" + webServiceFilterValue +"*";
        }
    }
    else
    {
        filterValue = "";
        webServiceFilterValue = "";
    }

    // =================================================================================================================
    // query SM for the list 
    // =================================================================================================================
    Collection<String> subcategoryList = null;
    String query = "";
    if ( processingPostBack )
    {
        query = categoriesQuery + " and ( subcategory " + webServiceQueryOp + " " + "\"" + webServiceFilterValue + "\")";
        //ServiceManagerScriptObject serviceManagerCmBean = new ServiceManagerScriptObject();

        serviceManagerCmBean.initializeClient( SERVICE_MANAGER_URL, SERVICE_MANAGER_USER, SERVICE_MANAGER_PASSWORD );

        subcategoryList = serviceManagerCmBean.getSortedList( "RetrieveCMSubcategoryListRequest", query, "subcategory" );
    }

%>

<%@ include file="SMCMJSInclude.jsp" %>
<script type="text/javascript">

  // Adds the list of selected items selected in the parent
  // window to this list.
  function updateCurrentSubcategoryNames()
  {
<%
    if ( !processingPostBack ) // do not want to load from the parent if this is a post back
    {
        // need to fetch the correct 'case' of the predicate name
        PredicateBean predicateBean = subscriptionBean.getPredicateByName( SUBCATEGORY_PREDICATE_NAME );
        String predicateId = predicateBean.getPredicateValueWidgetId();
%>
    var selectedItemsList = document.getElementById("items");

    var parentForm = self.opener.document.forms[0];
    var source = parentForm['<%= predicateId %>'];

    removeAllOptions( selectedItemsList );
    if(source.options.length != 0)
    {
      // copy from source to left list
      copyAllOptions(source, selectedItemsList);
    }
<%
    }
%>
  }

  function updateParentForm( childForm )
  {
    selectAllTargetOptions( childForm, 'items' );
    var source = childForm['items'];
    self.opener.updateCurrentSubcategories( source );
    self.close();
    return false;
  }


</script>

<form-template name="POPUP_FORM"
               onsubmit="selectAllTargetOptions(this, 'policyNames');"
               form-action="jsp/subscription/hpsmcm/SMCMSubCategory.jsp;jsessionid=<%= session.getId() + "?" + CATEGORY_PREDICATE_NAME + "=" + categoriesRaw%>">

<group label="Search Subcategories">

  <div class="no-list-table-data-title">
    <caption>
      <span style="white-space:normal;">To find a list of available subcategories, specify your search criteria, and then click "Get Subcategories". The search results will include subcategories within following categories only: <%= categoriesDisplay %></span>
    </caption>
  </div>

  <div class="form-group">
    <table>
      <tr>
        <th>Name</th><th>Operator</th><th>Value</th>
      </tr>
      <tr>
        <td>Subcategory</td>
        <td type="template">
          <select id="FilterOperator" name="FilterOperator">
            <option
<%
 if(filterOperator == null || filterOperator.equals("CONTAINS") || filterOperator.equals(""))
 {
%>
 selected="true"
<%
 }
%>
              value="CONTAINS">CONTAINS</option>
            <option
<%
 if(filterOperator != null && filterOperator.equals("ENDS_WITH"))
 {
%>
 selected="true"
<%
 }
%>
              value="ENDS_WITH">ENDS WITH</option>
            <option
<%
 if(filterOperator != null && filterOperator.equals("STARTS_WITH"))
 {
%>
 selected="true"
<%
 }
%>
              value="STARTS_WITH">STARTS WITH</option>
            <option
<%
 if(filterOperator != null && filterOperator.equals("MATCHES"))
 {
%>
 selected="true"
<%
 }
%>
              value="MATCHES">MATCHES</option>
          </select>
        </td>
        <td type="template">
          <input id="FilterValue" name="FilterValue" value="<%= filterValue %>"/>
        </td>
      </tr>
    </table>
  </div>

<!--
  <div style="display:none;visibility:hidden;">
    <input id="subcategoriesSelected" class="hidden" name="subcategoriesSelected"/>
  </div>
-->


  <action-button id="refreshButton" label="Get Subcategories" onclick="doPrePostActions();return true;" />

</group>

<div class="form-group">

  <div class="double-list-widget">
    <label>Available Subcategories:</label>
    <br clear="all"/>
    <select style="width:500px;" multiple="0" name="items.unselected" id="items.unselected" size="10" ondblclick="add();">
<%
  if ( subcategoryList != null )
  {
    for( String subcategoryName : subcategoryList )
    {
      String subcategoryNameEscaped = StringEscapeUtils.escapeHtml( subcategoryName );
      out.print( "<option value=\"" + subcategoryNameEscaped + "\">" + subcategoryNameEscaped + "</option>\n" );
    }
  }
%>
    </select>
  </div>

  <div class="double-list-button-cluster">
    <div class="float-none">
      <span id="addButton">
        <input id="addButton:input" class="double-list-action" name="addButton" type="button"
               onclick="add(); return false;" value="Add &gt;"/>
      </span>
      <br/>
      <span id="removeButton">
        <input id="removeButton:input" class="double-list-action" name="removeButton" type="button"
               onclick="remove(); return false;" value="&lt; Remove"/>
      </span>
    </div>
  </div>

  <div class="double-list-widget">
    <label>Selected Subcategories:</label>
    <br clear="all"/>
    <select  style="width:500px;" multiple="0" name="items" id="items" size="10" ondblclick="remove();">
<%
    if ( items != null )
    {
        for ( String item : items )
        {
           String escapedItem = StringEscapeUtils.escapeHtml( item );
           out.print( "<option value=\"" + escapedItem + "\">" + escapedItem + "</option>" );
        }
    }
%>
    </select>
  </div>
  
</div>


<action-button id="submitButton" label="Save" onclick="return updateParentForm(this.form);" />

</form-template>
</window-popup>
</page>
